---
title: WebAssembly.Memory.prototype.grow()
slug: Web/JavaScript/Reference/Global_Objects/WebAssembly/Memory/grow
tags:
  - API
  - JavaScript
  - Method
  - Reference
  - WebAssembly
  - grow
  - memory
---
<div>{{JSRef}}</div>

<p>The <strong><code>grow()</code></strong> protoype method of the <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/WebAssembly/Memory">Memory</a></code> object increases the size of the memory instance by a specified number of WebAssembly pages.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">memory.grow(<em>number</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em>number</em></dt>
 <dd>The number of WebAssembly pages you want to grow the memory by (each one is 64KiB in size).</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The previous size of the memory, in units of WebAssembly pages.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_grow">Using grow</h3>

<p>The following example creates a new WebAssembly Memory instance with an initial size of 1 page (64KiB), and a maximum size of 10 pages (640KiB).</p>

<pre class="brush: js">var memory = new WebAssembly.Memory({initial:1, maximum:10});</pre>

<p>We can then grow the instance by one page like so:</p>

<pre class="brush: js">const bytesPerPage = 64 * 1024;
console.log(memory.buffer.byteLength / bytesPerPage);  // "1"
console.log(memory.grow(1));                           // "1"
console.log(memory.buffer.byteLength / bytesPerPage);  // "2"
</pre>

<p>Note the return value of <code>grow()</code> here is the previous number of WebAssembly pages.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebAssembly JS', '#dom-memory-grow', 'grow()')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.WebAssembly.Memory.grow")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/WebAssembly">WebAssembly</a> overview page</li>
 <li><a href="/en-US/docs/WebAssembly/Concepts">WebAssembly concepts</a></li>
 <li><a href="/en-US/docs/WebAssembly/Using_the_JavaScript_API">Using the WebAssembly JavaScript API</a></li>
</ul>
